﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
            pictureBox1_SizeChanged (null, null);
        }

        private void runToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // this.Text = "Nadpis";
            // pictureBox1.Image = new Bitmap(1200, 800);
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            Pen p = new Pen (Color.Red);
            g.DrawLine (p, 0, 0, 100, 100);

            pictureBox1.Invalidate();
        }

        private void quitMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void pictureBox1_SizeChanged(object sender, EventArgs e)
        {
            int w = pictureBox1.ClientSize.Width;
            int h = pictureBox1.ClientSize.Height;
            if (w > 0 && h > 0)
            {
                int w0 = 0;
                int h0 = 0;
                if (pictureBox1.Image != null)
                {
                    w0 = pictureBox1.Image.Width;
                    h0 = pictureBox1.Image.Height;
                }

                // w = Math.Max(w, w0);
                // h = Math.Max(h, h0);

                Bitmap bmp = new Bitmap(w, h);

                Graphics g = Graphics.FromImage(bmp);
                Brush b = Brushes.Azure;
                g.FillRectangle(b, 0, 0, w, h);

                if (pictureBox1.Image != null)
                    g.DrawImage(pictureBox1.Image, 0, 0);
                    // g.DrawImage(pictureBox1.Image, 0, 0, w, h);

                pictureBox1.Image = bmp;
            }
        }

        private int X0, Y0;
        private bool stisknuto = false;
        private Bitmap save;
        private Pen pen = Pens.Yellow;

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisknuto = true;

            save = new Bitmap(pictureBox1.Image);
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                Graphics g = Graphics.FromImage(pictureBox1.Image);
                g.DrawImage(save, 0, 0);
                Pen p = Pens.Blue;
                // Pen p = new Pen (Color.Blue);
                // p.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDot;
                g.DrawLine(p, X0, Y0, e.X, e.Y);
                pictureBox1.Invalidate();
            }
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            stisknuto = false;
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            g.DrawLine (pen, X0, Y0, e.X, e.Y);
            pictureBox1.Invalidate();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
        }

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            // pen = Pens.Red;
            // Panel panel = sender as Panel;
            // Panel panel = (Panel) sender;
            Control panel = (Control)sender;
            if (e.Button == MouseButtons.Left)
            {
                pen = new Pen(panel.BackColor);
            }
            else if (e.Button == MouseButtons.Middle)
            {
                colorDialog1.ShowDialog();
                panel.BackColor = colorDialog1.Color;
            }

        }

        private int cnt = 2;

        private void newColorMenuItem_Click(object sender, EventArgs e)
        {
            Panel p = new Panel();
            p.Parent = toolbar;
            p.Height = panel1.Height;
            p.Width = panel1.Width;
            cnt++;
            p.Left = panel1.Left + (cnt - 1) * (panel2.Left - panel1.Left);
            p.Top = panel1.Top + (cnt - 1) * (panel2.Top - panel1.Top);
            p.BackColor = Color.Blue;
            p.MouseDown += panel1_MouseDown;
        }

    }
}
